library ieee;
use ieee.std_logic_1164.all;

package div100_pkg is 
	component div100 port(
		Tosc : in bit;
		T9 : out bit);
	end component;
end div100_pkg;

library ieee;
use ieee.std_logic_1164.all;

entity div100 is port (	
	Tosc : in bit;
	T9 : out bit);
end div100;

architecture archdiv100 of div100 is
	signal cpt : integer range 100 downto 0;

begin
	process (Tosc)
	begin
		if (Tosc'event and Tosc='1') then
			cpt <= cpt + 1;
	 			if (cpt >= 50)		then T9<='0';
									else T9<='1';
				end if;
				if (cpt >= 100) 		then cpt <= 0;
				end if;
		end if;
	end process;
end archdiv100;

library ieee;
use ieee.std_logic_1164.all;

package div10_1_pkg is 
	component div10_1 port(
		T9 : in bit;
		T8 : out bit);
	end component;
end div10_1_pkg;

library ieee;
use ieee.std_logic_1164.all;

entity div10_1 is port(	
	T9 : in bit;
	T8 : out bit);
end div10_1;

architecture archdiv10_1 of div10_1 is
	signal cpt : integer range 10 downto 0;

begin
	process (T9)
	begin
		if (T9'event and T9='1') then
			cpt <= cpt + 1;
	 			if (cpt >= 5)	then T8<='0';
								else T8<='1';
				end if;
				if (cpt >= 10) 	then cpt <= 0;
				end if;
		end if;
	end process;
end archdiv10_1;

library ieee;
use ieee.std_logic_1164.all;

package div10_2_pkg is 
	component div10_2 port(
		T8 : in bit;
		T7 : out bit);
	end component;
end div10_2_pkg;

library ieee;
use ieee.std_logic_1164.all;

entity div10_2 is port(	
	T8 : in bit;
	T7 : out bit);
end div10_2;

architecture archdiv10_2 of div10_2 is
	signal cpt : integer range 10 downto 0;

begin
	process (T8)
	begin
		if (T8'event and T8='1') then
			cpt <= cpt + 1;
	 			if (cpt >= 5)	then T7<='0';
								else T7<='1';
				end if;
				if (cpt >= 10) 	then cpt <= 0;
				end if;
		end if;
	end process;
end archdiv10_2;

library ieee;
use ieee.std_logic_1164.all;

package div10_3_pkg is 
	component div10_3 port(
		T7 : in bit;
		T6 : out bit);
	end component;
end div10_3_pkg;

library ieee;
use ieee.std_logic_1164.all;

entity div10_3 is port(	
	T7 : in bit;
	T6 : out bit);
end div10_3;

architecture archdiv10_3 of div10_3 is
	signal cpt : integer range 10 downto 0;

begin
	process (T7)
	begin
		if (T7'event and T7='1') then
			cpt <= cpt + 1;
	 			if (cpt >= 5)	then T6<='0';
								else T6<='1';
				end if;
				if (cpt >= 10) 	then cpt <= 0;
				end if;
		end if;
	end process;
end archdiv10_3;

library ieee;
use ieee.std_logic_1164.all;

package div10_4_pkg is 
	component div10_4 port(
		T6 : in bit;
		T5 : out bit);
	end component;
end div10_4_pkg;

library ieee;
use ieee.std_logic_1164.all;

entity div10_4 is port(	
	T6 : in bit;
	T5 : out bit);
end div10_4;

architecture archdiv10_4 of div10_4 is
	signal cpt : integer range 10 downto 0;

begin
	process (T6)
	begin
		if (T6'event and T6='1') then
			cpt <= cpt + 1;
	 			if (cpt >= 5)	then T5<='0';
								else T5<='1';
				end if;
				if (cpt >= 10) 	then cpt <= 0;
				end if;
		end if;
	end process;
end archdiv10_4;

library ieee;
use ieee.std_logic_1164.all;

package multiplexeur_1_pkg is 
	component multiplexeur_1 port(
		T9 : in bit;
		T8 : in bit;
		T7 : in bit;
		T6 : in bit;
		T5 : in bit;
		I9 : in bit;
		I8 : in bit;
		I7 : in bit;
		I6 : in bit;
		I5 : in bit;
		Tm : inout bit);
	end component;
end multiplexeur_1_pkg;

library ieee;
use ieee.std_logic_1164.all;

entity multiplexeur_1 is port (
	T9 : in bit;
	T8 : in bit;
	T7 : in bit;
	T6 : in bit;
	T5 : in bit;
	I9 : in bit;
	I8 : in bit;
	I7 : in bit;
	I6 : in bit;
	I5 : in bit;
	Tm : inout bit);
end multiplexeur_1;

architecture archmultiplexeur_1 of multiplexeur_1 is

begin
	process(I9,I8,I7,I6,I5)
	begin
		if (I9 & I8 & I7 & I6 & I5) = "10000" then
			Tm <= T9;
		elsif (I9 & I8 & I7 & I6 & I5) = "01000" then
			Tm <= T8;
		elsif (I9 & I8 & I7 & I6 & I5) = "00100" then
			Tm <= T7;
		elsif (I9 & I8 & I7 & I6 & I5) = "00010" then
			Tm <= T6;
		elsif (I9 & I8 & I7 & I6 & I5) = "00001" then
			Tm <= T5;
		end if;
	end process;
end archmultiplexeur_1;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all; 
use ieee.std_logic_arith.all; 
use ieee.std_logic_unsigned.all; 

package compteur_bcd_pkg is 
	component compteur_bcd port (
		Reset : in bit;
		Tmes : in bit;
		Digit_bcd_1 : out std_logic_vector(3 downto 0);
		Digit_bcd_2 : out std_logic_vector(3 downto 0);
		Digit_bcd_3 : out std_logic_vector(3 downto 0);
		Digit_bcd_4 : out std_logic_vector(3 downto 0));
	end component;
end compteur_bcd_pkg;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all; 
use ieee.std_logic_arith.all; 
use ieee.std_logic_unsigned.all; 

entity compteur_bcd is port (
	Reset : in bit;
	Tmes : in bit;
	Digit_bcd_1 : out std_logic_vector(3 downto 0);
	Digit_bcd_2 : out std_logic_vector(3 downto 0);
	Digit_bcd_3 : out std_logic_vector(3 downto 0);
	Digit_bcd_4 : out std_logic_vector(3 downto 0));
end compteur_bcd;

architecture archcompteur_bcd of compteur_bcd is
 	signal cpt_1, cpt_2, cpt_3, cpt_4 : std_logic_vector(3 downto 0);

begin
	process (Reset, Tmes)
	begin
	if (Reset='1') then
		cpt_1 <= (others =>'0');
		cpt_2 <= (others =>'0');
		cpt_3 <= (others =>'0');
		cpt_4 <= (others =>'0');
	elsif (Tmes='1' and Tmes'event ) then
		if (cpt_1 < 9)	then
			cpt_1 <= cpt_1 + 1;
		else	
			cpt_1 <= (others =>'0');
		if (cpt_2 < 9)	then
			cpt_2 <= cpt_2 + 1;
		else
			cpt_2 <= (others =>'0');
		if (cpt_3 < 9)	then
			cpt_3 <= cpt_3 + 1;
		else	
			cpt_3 <= (others =>'0');
		if (cpt_4 < 9)	then	
			cpt_4 <= cpt_4 + 1;																							
		else	
			cpt_4 <= (others =>'0');
		end if;
		end if;
		end if;
		end if;
	end if;			
	end process;
		Digit_bcd_1 <= cpt_1;
		Digit_bcd_2 <= cpt_2;
		Digit_bcd_3 <= cpt_3;
		Digit_bcd_4 <= cpt_4;
end archcompteur_bcd;

library ieee;
use ieee.std_logic_1164.all;

package latch_1_pkg is 
	component latch_1 port (
		Le : in bit;
		Digit_bcd_1 : in std_logic_vector(3 downto 0);
		Digit_bcd_2 : in std_logic_vector(3 downto 0);
		Digit_bcd_3 : in std_logic_vector(3 downto 0);
		Digit_bcd_4 : in std_logic_vector(3 downto 0);
		Digit_f_1 : out std_logic_vector(3 downto 0);
		Digit_f_2 : out std_logic_vector(3 downto 0);
		Digit_f_3 : out std_logic_vector(3 downto 0);
		Digit_f_4 : out std_logic_vector(3 downto 0));
	end component;
end latch_1_pkg;

library ieee;
use ieee.std_logic_1164.all;

entity latch_1 is port (
	Le : in bit;
	Digit_bcd_1 : in std_logic_vector(3 downto 0);
	Digit_bcd_2 : in std_logic_vector(3 downto 0);
	Digit_bcd_3 : in std_logic_vector(3 downto 0);
	Digit_bcd_4 : in std_logic_vector(3 downto 0);
	Digit_f_1 : out std_logic_vector(3 downto 0);
	Digit_f_2 : out std_logic_vector(3 downto 0);
	Digit_f_3 : out std_logic_vector(3 downto 0);
	Digit_f_4 : out std_logic_vector(3 downto 0));
end latch_1;

architecture archlatch_1 of latch_1 is

begin
	process(Le, digit_bcd_1, digit_bcd_2, digit_bcd_3, digit_bcd_4)
	begin
		if (Le='1' and Le'event) then
			Digit_f_1 <= Digit_bcd_1;
			Digit_f_2 <= Digit_bcd_2;
			Digit_f_3 <= Digit_bcd_3;
			Digit_f_4 <= Digit_bcd_4;
		end if;
	end process;
end archlatch_1;

library ieee;
use ieee.std_logic_1164.all;

package multiplexeur_2_pkg is
	component multiplexeur_2 port (
		VF : in bit;
		Digit_f_1 : in std_logic_vector(3 downto 0);
		Digit_f_2 : in std_logic_vector(3 downto 0);
		Digit_f_3 : in std_logic_vector(3 downto 0);
		Digit_f_4 : in std_logic_vector(3 downto 0);
		Digit_v_1 : in std_logic_vector(3 downto 0);
		Digit_v_2 : in std_logic_vector(3 downto 0);
		Digit_v_3 : in std_logic_vector(3 downto 0);
		Digit_v_4 : in std_logic_vector(3 downto 0);
		Digit_out_1 : out std_logic_vector(3 downto 0);
		Digit_out_2 : out std_logic_vector(3 downto 0);
		Digit_out_3 : out std_logic_vector(3 downto 0);
		Digit_out_4 : out std_logic_vector(3 downto 0));	
	end component;
end multiplexeur_2_pkg;

library ieee;
use ieee.std_logic_1164.all;

entity multiplexeur_2 is port (
	VF : in bit;
	Digit_f_1 : in std_logic_vector(3 downto 0);
	Digit_f_2 : in std_logic_vector(3 downto 0);
	Digit_f_3 : in std_logic_vector(3 downto 0);
	Digit_f_4 : in std_logic_vector(3 downto 0);
	Digit_v_1 : in std_logic_vector(3 downto 0);
	Digit_v_2 : in std_logic_vector(3 downto 0);
	Digit_v_3 : in std_logic_vector(3 downto 0);
	Digit_v_4 : in std_logic_vector(3 downto 0);
	Digit_out_1 : out std_logic_vector(3 downto 0);
	Digit_out_2 : out std_logic_vector(3 downto 0);
	Digit_out_3 : out std_logic_vector(3 downto 0);
	Digit_out_4 : out std_logic_vector(3 downto 0));
end multiplexeur_2;

architecture archmultiplexeur_2 of multiplexeur_2 is

begin
	Digit_out_1 <= Digit_f_1 when VF='1' else Digit_v_1;
	Digit_out_2 <= Digit_f_2 when VF='1' else Digit_v_2;
	Digit_out_3 <= Digit_f_3 when VF='1' else Digit_v_3;
	Digit_out_4 <= Digit_f_4 when VF='1' else Digit_v_4;
end archmultiplexeur_2;

library ieee;
use ieee.std_logic_1164.all;

package sept_segment_1_pkg is 
	component sept_segment_1 port (
		Digit_out_1 : in std_logic_vector (3 downto 0);
		Segment_1 : out std_logic_vector (6 downto 0));
	end component;
end sept_segment_1_pkg;

library ieee;
use ieee.std_logic_1164.all;

entity sept_segment_1 is port (
	Digit_out_1 : in std_logic_vector (3 downto 0);
	Segment_1 : out std_logic_vector (6 downto 0));
end sept_segment_1;

architecture archsept_segment_1 of sept_segment_1 is
begin
	with Digit_out_1 select
		Segment_1 <= 	"1111110" when "0000",
						"0110000" when "0001",
						"1101101" when "0010",
						"1111001" when "0011",
						"0110011" when "0100",
						"1011011" when "0101",
						"1011111" when "0110",
						"1110000" when "0111",
						"1111111" when "1000",
						"1111011" when "1001",
						"0000001" when others;
end archsept_segment_1;

library ieee;
use ieee.std_logic_1164.all;

package sept_segment_2_pkg is 
	component sept_segment_2 port (
		Digit_out_2 : in std_logic_vector (3 downto 0);
		Segment_2 : out std_logic_vector (6 downto 0));
	end component;
end sept_segment_2_pkg;

library ieee;
use ieee.std_logic_1164.all;

entity sept_segment_2 is port (
	Digit_out_2 : in std_logic_vector (3 downto 0);
	Segment_2 : out std_logic_vector (6 downto 0));
end sept_segment_2;

architecture archsept_segment_2 of sept_segment_2 is
begin
	with Digit_out_2 select
		Segment_2 <= 	"1111110" when "0000",
						"0110000" when "0001",
						"1101101" when "0010",
						"1111001" when "0011",
						"0110011" when "0100",
						"1011011" when "0101",
						"1011111" when "0110",
						"1110000" when "0111",
						"1111111" when "1000",
						"1111011" when "1001",
						"0000001" when others;
end archsept_segment_2;

library ieee;
use ieee.std_logic_1164.all;

package sept_segment_3_pkg is 
	component sept_segment_3 port (
		Digit_out_3 : in std_logic_vector (3 downto 0);
		Segment_3 : out std_logic_vector (6 downto 0));
	end component;
end sept_segment_3_pkg;

library ieee;
use ieee.std_logic_1164.all;

entity sept_segment_3 is port (
	Digit_out_3 : in std_logic_vector (3 downto 0);
	Segment_3 : out std_logic_vector (6 downto 0));
end sept_segment_3;

architecture archsept_segment_3 of sept_segment_3 is
begin
	with Digit_out_3 select
		Segment_3 <= 	"1111110" when "0000",
						"0110000" when "0001",
						"1101101" when "0010",
						"1111001" when "0011",
						"0110011" when "0100",
						"1011011" when "0101",
						"1011111" when "0110",
						"1110000" when "0111",
						"1111111" when "1000",
						"1111011" when "1001",
						"0000001" when others;
end archsept_segment_3;

library ieee;
use ieee.std_logic_1164.all;

package sept_segment_4_pkg is 
	component sept_segment_4 port (
		Digit_out_4 : in std_logic_vector (3 downto 0);
		Segment_4 : out std_logic_vector (1 downto 0));
	end component;
end sept_segment_4_pkg;

library ieee;
use ieee.std_logic_1164.all;

entity sept_segment_4 is port (
	Digit_out_4 : in std_logic_vector (3 downto 0);
	Segment_4 : out std_logic_vector (1 downto 0));
end sept_segment_4;

architecture archsept_segment_4 of sept_segment_4 is
begin
	with Digit_out_4 select
		Segment_4 <= 	"00" when "0000",
						"11" when "0001",
						"00" when others;
end archsept_segment_4;

library ieee;
use ieee.std_logic_1164.all;

package P_1_pkg is 
	component P_1 port(
		I2 : in bit;
		I5 : in bit;
		I8 : in bit;
		P1 : out bit);
	end component;
end P_1_pkg;

library ieee;
use ieee.std_logic_1164.all;

entity P_1 is port(	
	I2 : in bit;
	I5 : in bit;
	I8 : in bit;
	P1 : out bit);
end P_1;

architecture archP_1 of P_1 is

begin
	P1 <= I2 or I5 or I8;
end archP_1;

library ieee;
use ieee.std_logic_1164.all;

package P_2_pkg is 
	component P_2 port(
		I3 : in bit;
		I6 : in bit;
		I9 : in bit;
		P2 : out bit);
	end component;
end P_2_pkg;

library ieee;
use ieee.std_logic_1164.all;

entity P_2 is port(	
	I3 : in bit;
	I6 : in bit;
	I9 : in bit;
	P2 : out bit);
end P_2;

architecture archP_2 of P_2 is

begin
	P2 <= I3 or I6 or I9;
end archP_2;

library ieee;
use ieee.std_logic_1164.all;

package P_3_pkg is 
	component P_3 port(
		I1 : in bit;
		I4 : in bit;
		I7 : in bit;
		P3 : out bit);
	end component;
end P_3_pkg;

library ieee;
use ieee.std_logic_1164.all;

entity P_3 is port(	
	I1 : in bit;
	I4 : in bit;
	I7 : in bit;
	P3 : out bit);
end P_3;

architecture archP_3 of P_3 is

begin
	P3 <= I1 or I4 or I7;
end archP_3;

library ieee;
use ieee.std_logic_1164.all;

package miHz_1_pkg is 
	component miHz_1 port(
		I1 : in bit;
		miHz : out bit);
	end component;
end miHz_1_pkg;

library ieee;
use ieee.std_logic_1164.all;

entity miHz_1 is port(	
		I1 : in bit;
		miHz : out bit);
end miHz_1;

architecture archmiHz_1 of miHz_1 is

begin
	miHz <= I1;
end archmiHz_1;

library ieee;
use ieee.std_logic_1164.all;

package Hz_1_pkg is 
	component Hz_1 port(
		I1 : in bit;
		I2 : in bit;
		I3 : in bit;
		I4 : in bit;
		VF : out bit;
		Hz : out bit);
	end component;
end Hz_1_pkg;

library ieee;
use ieee.std_logic_1164.all;

entity Hz_1 is port(	
	I1 : in bit;
	I2 : in bit;
	I3 : in bit;
	I4 : in bit;
	VF : out bit;
	Hz : out bit);
end Hz_1;

architecture archHz_1 of Hz_1 is

begin
	Hz <= I2 or I3 or I4;
	VF <= I1 or I2 or I3 or I4;
end archHz_1;

library ieee;
use ieee.std_logic_1164.all;

package kHz_1_pkg is 
	component kHz_1 port(
		I5 : in bit;
		I6 : in bit;
		I7 : in bit;
		Tm : inout bit;
		kHz : out bit);
	end component;
end kHz_1_pkg;

library ieee;
use ieee.std_logic_1164.all;

entity kHz_1 is port(	
	I5 : in bit;
	I6 : in bit;
	I7 : in bit;
	Tm : inout bit;
	kHz : out bit);
end kHz_1;

architecture archkHz_1 of kHz_1 is

begin
	kHz <= ((I5 or I6 or I7) and Tm);
end archkHz_1;

library ieee;
use ieee.std_logic_1164.all;

package MeHz_1_pkg is 
	component MeHz_1 port(
		I8 : in bit;
		I9 : in bit;
		MeHz : out bit);
	end component;
end MeHz_1_pkg;

library ieee;
use ieee.std_logic_1164.all;

entity MeHz_1 is port(	
	I8 : in bit;
	I9 : in bit;
	MeHz : out bit);
end MeHz_1;

architecture archMeHz_1 of MeHz_1 is

begin
	MeHz <= I8 or I9;
end archMeHz_1;

library ieee;
use ieee.std_logic_1164.all;

library work;
use work.div100_pkg.all;
use work.div10_1_pkg.all;
use work.div10_2_pkg.all;
use work.div10_3_pkg.all;
use work.div10_4_pkg.all;
use work.multiplexeur_1_pkg.all;
use work.compteur_bcd_pkg.all;
use work.latch_1_pkg.all;
use work.multiplexeur_2_pkg.all;
use work.sept_segment_1_pkg.all;
use work.sept_segment_2_pkg.all;
use work.sept_segment_3_pkg.all;
use work.sept_segment_4_pkg.all;
use work.P_1_pkg.all;
use work.P_2_pkg.all;
use work.P_3_pkg.all;
use work.miHz_1_pkg.all;
use work.Hz_1_pkg.all;
use work.kHz_1_pkg.all;
use work.MeHz_1_pkg.all;

entity afficheur is port (
	Tosc : in bit;
	I9 : in bit;
	I8 : in bit;
	I7 : in bit;
	I6 : in bit;
	I5 : in bit;
	I4 : in bit;
	I3 : in bit;
	I2 : in bit;
	I1 : in bit;
	Tmes : in bit;
	Reset : in bit;
	Le : in bit;
	Digit_v_1 : in std_logic_vector(3 downto 0);
	Digit_v_2 : in std_logic_vector(3 downto 0);
	Digit_v_3 : in std_logic_vector(3 downto 0);
	Digit_v_4 : in std_logic_vector(3 downto 0);
	Tm : inout bit;
	P1 : out bit;
	P2 : out bit;
	P3 : out bit;
	miHz : out bit;
	Hz : out bit;
	kHz : out bit;
	MeHz : out bit;
	Segment_1 : out std_logic_vector(6 downto 0);
	Segment_2 : out std_logic_vector(6 downto 0);
	Segment_3 : out std_logic_vector(6 downto 0);
	Segment_4 : out std_logic_vector(1 downto 0));
end afficheur;

architecture archafficheur of afficheur is
	signal T9 : bit;
	signal T8 : bit;
	signal T7 : bit;
	signal T6 : bit;
	signal T5 : bit;
	signal VF : bit;
	signal Digit_bcd_1 : std_logic_vector (3 downto 0);
	signal Digit_bcd_2 : std_logic_vector (3 downto 0);
	signal Digit_bcd_3 : std_logic_vector (3 downto 0);
	signal Digit_bcd_4 : std_logic_vector (3 downto 0);
	signal Digit_f_1 : std_logic_vector (3 downto 0);
	signal Digit_f_2 : std_logic_vector (3 downto 0);
	signal Digit_f_3 : std_logic_vector (3 downto 0);
	signal Digit_f_4 : std_logic_vector (3 downto 0);
	signal Digit_out_1 : std_logic_vector (3 downto 0);
	signal Digit_out_2 : std_logic_vector (3 downto 0);
	signal Digit_out_3 : std_logic_vector (3 downto 0);
	signal Digit_out_4 : std_logic_vector (3 downto 0);
 
begin
	F1 : div100 port map (Tosc,T9);
	F2 : div10_1 port map (T9,T8);
	F3 : div10_2 port map (T8,T7);
	F4 : div10_3 port map (T7,T6);
	F5 : div10_4 port map (T6,T5);
	F6 : multiplexeur_1 port map (T9,T8,T7,T6,T5,I9,I8,I7,I6,I5,Tm);
	F7 : compteur_bcd port map (Reset,Tmes,Digit_bcd_1,Digit_bcd_2,Digit_bcd_3,Digit_bcd_4);
	F8 : latch_1 port map (Le,Digit_bcd_1,Digit_bcd_2,Digit_bcd_3,Digit_bcd_4,Digit_f_1,Digit_f_2,Digit_f_3,Digit_f_4);
	F9 : multiplexeur_2 port map(VF,Digit_v_1,Digit_v_2,Digit_v_3,Digit_v_4,Digit_f_1,Digit_f_2,Digit_f_3,Digit_f_4,Digit_out_1,Digit_out_2,Digit_out_3,Digit_out_4);
	F10 : sept_segment_1 port map (Digit_out_1,Segment_1);
	F11 : sept_segment_2 port map (Digit_out_2,Segment_2);
	F12 : sept_segment_3 port map (Digit_out_3,Segment_3);
	F13 : sept_segment_4 port map (Digit_out_4,Segment_4);
	F14 : P_1 port map (I2,I5,I8,P1);
	F15 : P_2 port map (I3,I6,I9,P2);
	F16 : P_3 port map (I1,I4,I7,P3);
	F17 : miHz_1 port map (I1,miHz);
	F18 : Hz_1 port map (I1,I2,I3,I4,Hz);
	F19 : kHz_1 port map (I5,I6,I7,Tm,kHz);
	F20 : MeHz_1 port map (I8,I9,MeHz);
end archafficheur;